<?php
include_once("path.php");
include_once("dom.php");
$csv=array();
$cellnum=count($csv);
$handle=0;
$fh=0;
$sitemap="";
$rootlen=0;
$ininame="";
$ignoreImage=true;
$pagesOnly=true;
$siteurl="";
$sitecount="";
$filecount=0;
$dircount=0;
$filesToExclude=array("index.php","header.php","top.php","sidebar.php","footer.php","bottom.php");
$extToExclude=array(".zip",".gz",".exe",".xml",".css",".js",".txt");
$imgExtensions=array(".jpg",".png",".gif",".jpeg",".bmp",".ico");
function loadIni($name)
{
   $ini=array();
   if(!Path::exists($name))
   {
      $oldname=$name;
      $name.=".ini";
      if(!Path::exists($name))
      {
         die("Ini file '$oldname' or $name' not found.");
      }
   }
   $ini=file($name);
   reset($ini);
   do
   {
      $line= current($ini);
      $line=trim($line);
      if(trim($line)==="")
      {
         continue;
      }
      if(substr($line,0,3)==="map")
      {
         global $sitemap;
         $sitemap=substr($line,4);
         continue;
      }
      if(substr($line,0,3)==="csv")
      {
         global $csv;
         array_push($csv,substr($line,4));
      }
   }
   while(!(next($ini) === false));

   global $csv;
   reset($csv);
   do
   {
      $c= current($csv);
      echo "CSV:", " ", $c, "\n";
   }
   while(!(next($csv) === false));

   return;
}

$sheets=array();
function splitCSVLine($iline)
{
   $l=strlen($iline);
   $inquote=false;
   for($i=0;$i<$l;$i++)
   {
      if(($iline{$i}==='"')||($iline{$i}==="'"))
      {
         $inquote=!$inquote;
      }
      if($iline{$i}===",")
      {
         if($inquote)
         {
            $iline{$i}='.';
         }
      }
   }
   return explode(",",$iline);
}

function loadCSV()
{
   global $csv;
   reset($csv);
   do
   {
      $csvname= current($csv);
      $rawcsv=array();
      if(!Path::exists($csvname))
      {
         die("Error, $csvname not found!");
      }
      $rawcsv=file($csvname);
      $urlist=array();
      reset($rawcsv);
      do
      {
         $row= current($rawcsv);
         $rowcells=splitCSVLine($row);
         $url=$rowcells[0];
         $url=trim($url);
         if(substr($url,0,4)==='http')
         {
            global $siteurl;
            $siteurl=$url;
            global $rootlen;
            $rootlen=strlen($url)-1;
            echo "Site url:", " ", $siteurl, "\n";
            global $sitecount;
            $sitecount=$rowcells[2];
            continue;
         }
         if($url{0}==='/')
         {
            $val=$rowcells[2];
            $urlist[$url]=$val;
         }
      }
      while(!(next($rawcsv) === false));

      asort($urlist);
      global $sheets;
      array_push($sheets,$urlist);
   }
   while(!(next($csv) === false));

   return;
}

function extFilter($url)
{
   $ext=Path::getExtension($url);
   global $ignoreImage;
   global $imgExtensions;
   if($ignoreImage&&(in_array($ext,$imgExtensions)))
   {
      return true;
   }
   global $pagesOnly;
   if($pagesOnly)
   {
      global $extToExclude;
      if(in_array($ext,$extToExclude))
      {
         return true;
      }
   }
   return false;
}

function getCount($sheet,$url)
{
   global $sheets;
   $s=$sheets[$sheet];
   if(!array_key_exists($url,$s))
   {
      return 0;
   }
   return intVal($s[$url]);
}

function tohtml($str)
{
   global $fh;
   fwrite($fh,$str);
   return;
}

function addEntry($fullpath)
{
   global $rootlen;
   $relpath=substr($fullpath,$rootlen);
   tohtml("<tr>");
   tohtml("<td>$relpath</td>");
   $first=0;
   $last=0;
   global $cellnum;
   for($cn=0;$cn<=$cellnum;$cn++)
   {
      $backlinks=getCount($cn,$relpath);
      if($cn===0)
      {
         $first=$cn;
      }
      if($cn===$cellnum)
      {
         $last=$cn;
      }
      tohtml("<td>$backlinks</p>");
   }
   global $cellnum;
   if($cellnum>1)
   {
      $diff=$last-$first;
      tohtml("<td>$diff</td>");
   }
   tohtml("</tr>\n");
   return;
}

function readMap($mapname)
{
   if(!Path::exists($mapname))
   {
      echo "Sitemap '$mapname' not found.", "\n";
      exit();
   }
   $doc=new DOMDocument();
   $locs=new DOMNodeList();
   $node=new DOMNode();
   $url=null;

   $doc->load($mapname);
   $locs=$doc->getElementsByTagName("loc");
   $node=$locs->item(0);

   $filelist=array();
   $i=0;
   for($i=0;$i<$locs->length;$i++)
   {
      $node=$locs->item($i);
      $fname=$node->textContent;
      echo "Node: ", " ", $fname, "\n";
      if($fname==="")
      {
         die("empty");
      }
      if($fname ==false)
      {
         break;
      }
      if(extFilter($fname))
      {
         continue;
      }
      addEntry($fname);
      global $filecount;
      $filecount+=1;
   }
   return;
}

echo "Type the name of an ini file or press Enter : ";
$fp=fopen("php://stdin","r");
$ininame=rtrim(fgets($fp,65536));
fclose($fp);
if($ininame==="")
{
   $ininame="backcount.ini";
}

echo "Loading configuration file", " ", $ininame, "\n";
loadIni($ininame);
echo "Loading sitemap ", " ", $sitemap, "\n";

if(!Path::exists($sitemap))
{
   die("File '$sitemap' not found.");
}
$rootlen=strlen($sitemap);

loadCSV();
$outname=$csv[count($csv)-1];
$outname=substr($outname,0,22).".html";

$fh=fopen($outname,"w");

tohtml("<!DOCTYPE html\n");
tohtml("<html>\n");
tohtml("<head>\n");
tohtml("<link type='text/css' href='backcount.css' rel='stylesheet'>\n");
tohtml("</head>\n");
tohtml("<body>\n");
tohtml("<h1>$siteurl -   $sitecount</h1>\n");
tohtml("<table>\n<tr><td><b><u>Page</u></b>");
for($i=1;$i<=count($csv);$i++)
{
   tohtml("</td><td><b><u>Backlinks</u></b></td>");
}

if(count($csv)>1)
{
   tohtml("<td>Diff</td>");
}
tohtml("</tr>\n");
readMap($sitemap);
tohtml("</table>");
tohtml("</div></body></html>");
tohtml("<p>$filecount files.</p>");
tohtml("<p>$dircount dirs.</p>");
fclose($fh);

echo "Done.", "\n";

?>
